#include <windows.h>
#include <commctrl.h>
#include <tlhelp32.h>

typedef DWORD (*PFNNvRmDiagGetTemperature)(DWORD, DWORD, DWORD*);
PFNNvRmDiagGetTemperature NvRmDiagGetTemperature;//  NvError NvRmDiagGetTemperature(NvRmDeviceHandle hRmDeviceHandle, NvRmTmonZoneId ZoneId, NvS32 * pTemperatureC);
#define SOC_ZONE 2

int wmain() 
{
	HMODULE		hMod;									// Handle to loaded dll used
	DWORD		g_rm		= 0;
	DWORD		temperature = 0;						// variable to hold temperature value
	hMod = LoadLibrary(L"libnvrm.dll");
	if(!hMod)
	{
		printf("GetLastError %d\r\n", GetLastError());	// Load libnvrm.dll which contain function to readd temperature
		printf("Unable to load libnvrm.dll\r\n");
		return -1;
	}
	NvRmDiagGetTemperature = GetProcAddress(hMod, L"NvRmDiagGetTemperature");
	if(!NvRmDiagGetTemperature)
	{
		printf("GetLastError %d\r\n", GetLastError());
		printf("NvRmDiagGetTemperature ERROR\r\n");
		return -1;
	}
	NvRmDiagGetTemperature(g_rm, SOC_ZONE, &temperature);
	printf("CPU temperature = %d 'C\n\r", temperature);
	printf("Press enter to exit\n");
	getchar();
	return 0;
}

